(***********************************************************************)
(*                                                                     *)
(*                           HWeak                                     *)
(*                                                                     *)
(*                        Remi Vanicat                                 *)
(*                                                                     *)
(*  Copyright 2002 Rmi Vanicat                                        *)
(*  All rights reserved.  This file is distributed under the terms of  *)
(*  the GNU Library General Public License, with the special exception *)
(*  on linking described in the LICENCE file of the Objective Caml     *)
(*  distribution                                                       *)
(*                                                                     *)
(***********************************************************************)

module EmptyHashed =
struct
  type t = < >
  let equal = (=)
  let hash = Hashtbl.hash
end

module EmptyHash = Hweak.Make(EmptyHashed)

class ['a] c size =
object
  constraint 'a = < .. >
  val tbl = EmptyHash.create size

  method virtual add : 'a -> unit
  method add x =
    EmptyHash.replace tbl (x : < .. > :> < > ) x

  method virtual find : 'b. (< .. > as 'b) -> 'a
  method find x =
    EmptyHash.find tbl (x : < .. > :> < >)

  method virtual mem : 'b. (< .. > as 'b) -> bool
  method mem x =
    EmptyHash.mem tbl (x : < .. > :> < >)

  method virtual remove : 'b. (< .. > as 'b)  -> unit
  method remove x =
    EmptyHash.remove tbl (x : < .. > :> < >)

  method clear () =
    EmptyHash.clear tbl

  method count =
    EmptyHash.count tbl

end
